--- //SpectraBSD/stable/sys/dev/aic7xxx/aic7xxx.c	2012-08-29 22:35:04.000000000 -0600
+++ /usr/home/justing/perforce/SpectraBSD/sys/dev/aic7xxx/aic7xxx.c	2012-08-29 22:35:04.000000000 -0600
@@ -7043,7 +7043,6 @@
 		u_int	saved_scbptr;
 		int	target;
 		int	lun;
-		int	i;
 		char	channel;
 
 		target = SCB_GET_TARGET(ahc, scb);
@@ -7051,15 +7050,9 @@
 		lun = SCB_GET_LUN(scb);
 
 		ahc_print_path(ahc, scb);
-		printf("SCB 0x%x - timed out\n", scb->hscb->tag);
-		if (scb->sg_count > 0) {
-			for (i = 0; i < scb->sg_count; i++) {
-				printf("sg[%d] - Addr 0x%x : Length %d\n",
-				       i,
-				       scb->sg_list[i].addr,
-				       scb->sg_list[i].len & AHC_SG_LEN_MASK);
-			}
-		}
+		printf("Timed out ");
+		ahc_print_scb(scb)
+
 		if (scb->flags & (SCB_DEVICE_RESET|SCB_ABORT)) {
 			/*
 			 * Been down this road before.
--- //SpectraBSD/stable/sys/dev/aic7xxx/aic_osm_lib.c	2012-06-29 17:23:35.000000000 -0600
+++ /usr/home/justing/perforce/SpectraBSD/sys/dev/aic7xxx/aic_osm_lib.c	2012-06-29 17:23:35.000000000 -0600
@@ -113,13 +113,14 @@
 	aic_lock(aic);
 	for (;;) {
 		
-		if (LIST_EMPTY(&aic->timedout_scbs) != 0
-		 && (aic->flags & AIC_SHUTDOWN_RECOVERY) == 0)
-			msleep(aic, &aic->platform_data->mtx, PUSER, "idle", 0);
-
 		if ((aic->flags & AIC_SHUTDOWN_RECOVERY) != 0)
 			break;
 
+		if (LIST_EMPTY(&aic->timedout_scbs) != 0) {
+			msleep(aic, &aic->platform_data->mtx, PUSER, "idle", 0);
+			continue;
+		}
+
 		aic_recover_commands(aic);
 	}
 	aic->platform_data->recovery_thread = NULL;
